package cn.superdesk.libs.common2.uniexcel;

import net.sf.json.JSONObject;

import org.apache.poi.hssf.usermodel.*;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.DataFormat;
import org.apache.poi.ss.util.CellRangeAddress;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.*;


public class ExcelUtils {

    private static final Logger logger = LoggerFactory.getLogger(ExcelUtils.class);

    public static void main(String[] args) throws Exception {

        /*
         * File file = new File("d:1234.xlsx");
         *
         * String[][] result = getData(file, 1);
         *
         * int rowLength = result.length;
         *
         * for(int i=0;i<rowLength;i++) {
         *
         * for(int j=0;j<result[i].length;j++) {
         *
         * System.out.print(result[i][j]+"\t\t"); }
         *
         * System.out.println(); }
         */

        List<Map<String, Object>> list = new ArrayList<Map<String, Object>>();
        for (int i = 0; i < 10; i++) {
            Map<String, Object> map = new HashMap<String, Object>();
            map.put("name1", "第一个——" + i);
            map.put("name2", "第er个——" + i);
            map.put("name3", "第san个——" + i);
            list.add(map);
        }
        // exportExcel(list);

    }

    /**
     * 操作Excel2003以前（包括2003）的版本,扩展名是.xls
     *
     * @param templetFile 文件
     * @param startrow    开始行号
     * @param startcol    开始列号
     * @param sheetnum    sheet
     * @return list
     */
    public static List<Map<String, String>> readExcelByXls(InputStream inputStream, int startrow, int startcol, int sheetnum) {
        List<Map<String, String>> varList = new ArrayList<Map<String, String>>();

        try {

            HSSFWorkbook wb = new HSSFWorkbook(inputStream);
            HSSFSheet sheet = wb.getSheetAt(sheetnum); // sheet 从0开始
            int rowNum = sheet.getLastRowNum() + 1; // 取得最后一行的行号
            for (int i = startrow; i < rowNum - 1; i++) { // 行循环开始

                Map<String, String> varpd = new HashMap<String, String>();
                HSSFRow row = sheet.getRow(i); // 行
                int num = 0;
                int cellNum = row.getLastCellNum(); // 每行的最后一个单元格位置
                for (int j = startcol; j < cellNum; j++) { // 列循环开始
                    HSSFCell cell = row.getCell(Integer.parseInt(j + ""));
                    String cellValue = null;
                    if (null != cell) {
                        switch (cell.getCellType()) { // 判断excel单元格内容的格式，并对其进行转换，以便插入数据库
                            case 0:
                                if (HSSFDateUtil.isCellDateFormatted(cell)) {
                                    SimpleDateFormat sdf = new SimpleDateFormat(
                                            "yyyy-MM-dd HH:mm:ss");
                                    cellValue = sdf.format(
                                            HSSFDateUtil.getJavaDate(cell
                                                    .getNumericCellValue()))
                                            .toString();
                                } else {
                                    cell.setCellType(1);
                                    cellValue = cell.getStringCellValue();
                                }
                                break;
                            case 1:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = cell.getStringCellValue();
                                break;
                            case 2:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = String.valueOf(cell.getDateCellValue());
                                break;
                            case 3:
                                num++;
                                cellValue = "";
                                break;
                            case 4:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = String.valueOf(cell.getBooleanCellValue());
                                break;
                            case 5:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = String.valueOf(cell.getErrorCellValue());
                                break;
                        }
                        varpd.put("var" + j, cellValue);
                    }

                }
                if (num < cellNum) {
                    varList.add(varpd);
                }
            }

        } catch (Exception e) {
            System.out.println(e);
        }

        return varList;
    }

    /**
     * 是操作Excel2007的版本，扩展名是.xlsx
     *
     * @param inputStream 文件
     * @param startrow    开始行号
     * @param startcol    开始列号
     * @param sheetnum    sheet
     * @return list
     */
    public static List<Map<String, String>> readExcelByXlsx(
            InputStream inputStream, int startrow, int startcol, int sheetnum) {
        List<Map<String, String>> varList = new ArrayList<Map<String, String>>();

        try {

            XSSFWorkbook wb = new XSSFWorkbook(inputStream);
            XSSFSheet sheet = wb.getSheetAt(sheetnum); // sheet 从0开始
            int rowNum = sheet.getLastRowNum() + 1; // 取得最后一行的行号
            for (int i = startrow; i < rowNum - 1; i++) { // 行循环开始
                int num = 0;

                Map<String, String> varpd = new HashMap<String, String>();
                XSSFRow row = sheet.getRow(i); // 行
                int cellNum = row.getLastCellNum(); // 每行的最后一个单元格位置

                for (int j = startcol; j < cellNum; j++) { // 列循环开始

                    String cellValue = null;
                    XSSFCell cell = row.getCell(Integer.parseInt(j + ""));
                    if (null != cell) {
                        switch (cell.getCellType()) { // 判断excel单元格内容的格式，并对其进行转换，以便插入数据库
                            case 0:
                                if (HSSFDateUtil.isCellDateFormatted(cell)) {
                                    SimpleDateFormat sdf = new SimpleDateFormat(
                                            "yyyy-MM-dd HH:mm:ss");
                                    cellValue = sdf.format(
                                            HSSFDateUtil.getJavaDate(cell
                                                    .getNumericCellValue()))
                                            .toString();
                                } else {
                                    cell.setCellType(1);
                                    cellValue = cell.getStringCellValue();
                                }
                                break;
                            case 1:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = cell.getStringCellValue();
                                break;
                            case 2:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = cell.getStringCellValue();
                                break;
                            case 3:
                                num++;
                                cellValue = "";
                                break;
                            case 4:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = String.valueOf(cell.getBooleanCellValue());
                                break;
                            case 5:
                                cell.setCellType(Cell.CELL_TYPE_STRING);
                                cellValue = String.valueOf(cell.getErrorCellValue());
                                break;
                        }
                        varpd.put("var" + j, cellValue);
                    }

                }
                if (num < cellNum) {//去掉空行
                    varList.add(varpd);
                }
            }

        } catch (Exception e) {
            System.out.println(e);
        }

        return varList;
    }

    public static String getPath() throws IOException {

        File file = File.createTempFile("tempFile", ".xls"); // 创建临时文件
        String filePath = file.getPath();
        filePath = filePath.replace("\\\\", "/");

        File dir = new File(file.getPath());
        // 如果这个目录不存在，则创建它。
        if (!dir.exists()) {
            dir.mkdir();
        }

        return filePath;
    }

    @SuppressWarnings("deprecation")
    public static <T> File export(File file, HSSFWorkbook wb, String sheetName, List<T> list, String[] titles, String[] fieldNames) {

        HSSFSheet sheet = null;

        // 对每个表生成一个新的sheet,并以表名命名
        if (sheetName == null) {
            sheetName = "Sheet1";
        }

        sheet = wb.createSheet(sheetName);
        HSSFCellStyle headStyle = createCellStyle(wb, (short) 10, true, false);

        // 设置表头的说明
        HSSFRow topRow = sheet.createRow(0);
        for (int i = 0; i < titles.length; i++) {
//			setCellGBKValue(topRow.createCell((short) i), titles[i]);
            HSSFCell cells = topRow.createCell((short) i);
            setCellGBKValue(cells, titles[i]);
            cells.setCellStyle(headStyle);
        }

        DataFormat format = wb.createDataFormat();
        CellStyle style = wb.createCellStyle();
        style.setDataFormat(format.getFormat("@"));

        for (int i = 0; i < list.size(); i++) {

            HSSFRow row = sheet.createRow(i + 1);
            JSONObject obj = JSONObject.fromObject(list.get(i));
            for (int j = 0; j < fieldNames.length; j++) {
                HSSFCell cells = row.createCell((short) j);
//				setCellGBKValue(cells, obj.get(fieldNames[j])+"");
//				if(StringUtils.isBlank(obj.get(fieldNames[j])+"")){
//					logger.info("进入设置文本格式--------------");
//					cells.setCellStyle(style);
//				}
                if ("0".equals(obj.get(fieldNames[j]) + "") || obj.get(fieldNames[j]) == null || "null".equals(obj.get(fieldNames[j]) + "")) {
                    setCellGBKValue(cells, "");
                } else {
                    setCellGBKValue(cells, obj.get(fieldNames[j]) + "");
                }

                logger.info("进入设置文本格式--------------");
                cells.setCellStyle(style);
            }
        }
        setSheetAutoSizeColumn(titles, sheet);

        try {
            logger.info("-----------开始写入-------------------");

            OutputStream os = new FileOutputStream(file);
            wb.write(os);
            os.flush();
            os.close();

        } catch (Exception e) {

            logger.error(e.getMessage());
            e.printStackTrace();
            return null;
        }

        return file;
    }

    private static void setCellGBKValue(HSSFCell cell, String value) {
        try {
            if (Integer.parseInt(value) == 0 || Integer.parseInt(value) > 0) {
                cell.setCellType(HSSFCell.CELL_TYPE_NUMERIC);
                cell.setCellValue(Integer.parseInt(value));
            } else {
                cell.setCellType(HSSFCell.CELL_TYPE_STRING);
                cell.setCellValue(value);
            }
        } catch (Exception e) {
            cell.setCellType(HSSFCell.CELL_TYPE_STRING);
            cell.setCellValue(value);
        }


    }

    /**
     * 一个文档多个页签时的导出excel
     *
     * @param file
     * @param wb
     * @param sheetName
     * @param list
     * @param titles
     * @param fieldNames
     * @return
     */
    @SuppressWarnings("deprecation")
    public static <T> File exportExcel(File file, HSSFWorkbook wb, String sheetName, List<T> list, String[] titles, String[] fieldNames) {

        HSSFSheet sheet = null;

        // 对每个表生成一个新的sheet,并以表名命名
        if (sheetName == null) {
            sheetName = "Sheet1";
        }

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();

        sheet = wb.createSheet(sheetName);

        HSSFCellStyle dateStyle = createCellStyle(wb, (short) 10, true, false);
        HSSFCellStyle headStyle = createCellStyle(wb, (short) 10, true, false);

        CellRangeAddress callRangeAddress = new CellRangeAddress(0, 0, 0, 1);
        sheet.addMergedRegion(callRangeAddress);
        HSSFRow dateRow = sheet.createRow(0);
        HSSFCell cell = dateRow.createCell(0);
        cell.setCellStyle(dateStyle);
        cell.setCellValue("日期：" + sdf.format(date));
        // 设置表头的说明
        HSSFRow topRow = sheet.createRow(1);

        DataFormat format = wb.createDataFormat();
        CellStyle style = wb.createCellStyle();
        style.setDataFormat(format.getFormat("@"));

        for (int i = 0; i < titles.length; i++) {
            HSSFCell cells = topRow.createCell((short) i);
            setCellGBKValue(cells, titles[i]);
            cells.setCellStyle(headStyle);
//				sheet.setColumnWidth(i, 10000);
        }

        for (int i = 0; i < list.size(); i++) {

            HSSFRow row = sheet.createRow(i + 2);

            JSONObject obj = JSONObject.fromObject(list.get(i));

            for (int j = 0; j < fieldNames.length; j++) {

                HSSFCell cells = row.createCell((short) j);

                if ("0".equals(obj.get(fieldNames[j]) + "") || obj.get(fieldNames[j]) == null || "null".equals(obj.get(fieldNames[j]) + "")) {
                    setCellGBKValue(cells, "");
                } else {
                    setCellGBKValue(cells, obj.get(fieldNames[j]) + "");
                }

                logger.info("进入设置文本格式--------------");

                cells.setCellStyle(style);
            }
        }

        setSheetAutoSizeColumn(titles, sheet);

        try {
            logger.info("-----------开始写入-------------------");
            OutputStream os = new FileOutputStream(file);
            wb.write(os);
            os.flush();
            os.close();
        } catch (Exception e) {
            logger.error(e.getMessage());
            e.printStackTrace();
            return null;
        }

        return file;
    }

    /**
     * 一个文档多个页签时的导出excel
     *
     * @param file
     * @param wb
     * @param sheetName
     * @param list
     * @param titles
     * @param fieldNames
     * @return
     */
    @SuppressWarnings("deprecation")
    public static <T> File exportExcelNoDate(
            File file,
            HSSFWorkbook wb,
            String sheetName,
            List<T> list,
            String[] titles,
            String[] fieldNames) {

        HSSFSheet sheet = null;

        // 对每个表生成一个新的sheet,并以表名命名
        if (sheetName == null) {
            sheetName = "Sheet1";
        }

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date date = new Date();

        sheet = wb.createSheet(sheetName);
        HSSFCellStyle dateStyle = createCellStyle(wb, (short) 10, true, false);
        HSSFCellStyle headStyle = createCellStyle(wb, (short) 10, true, false);

        //CellRangeAddress callRangeAddress = new CellRangeAddress(0,0,0,1);
        //sheet.addMergedRegion(callRangeAddress);

		/*
		HSSFRow dateRow = sheet.createRow(0);
		HSSFCell cell = dateRow.createCell(0);
		cell.setCellStyle(dateStyle);
		cell.setCellValue("日期："+sdf.format(date));
		*/

        // 设置表头的说明
        HSSFRow topRow = sheet.createRow(0);

        for (int i = 0; i < titles.length; i++) {
            HSSFCell cells = topRow.createCell((short) i);
            setCellGBKValue(cells, titles[i]);
            cells.setCellStyle(headStyle);
        }

        for (int i = 0; i < list.size(); i++) {
            HSSFRow row = sheet.createRow(i + 1);
            JSONObject obj = JSONObject.fromObject(list.get(i));

            for (int j = 0; j < fieldNames.length; j++) {
                if ("0".equals(obj.get(fieldNames[j]) + "") || obj.get(fieldNames[j]) == null || "null".equals(obj.get(fieldNames[j]) + "")) {
                    setCellGBKValue(row.createCell((short) j), "");
                } else {
                    setCellGBKValue(row.createCell((short) j), obj.get(fieldNames[j]) + "");
                }
            }
        }

        setSheetAutoSizeColumn(titles, sheet);

        try {
            logger.info("-----------开始写入-------------------");
            OutputStream os = new FileOutputStream(file);
            wb.write(os);
            os.flush();
            os.close();
        } catch (Exception e) {
            logger.error(e.getMessage());
            e.printStackTrace();
            return null;
        }
        return file;
    }


    //excel列宽自适应
    private static void setSheetAutoSizeColumn(String[] titles, HSSFSheet sheet) {
        for (int i = 0; i < titles.length; i++) {
            sheet.autoSizeColumn((short) i);
        }

        int maxColumn = titles.length;
        //列宽自适应，只对英文和数字有效
			/*for (int i = 0; i <= titles.length; i++)
			{
			    sheet.autoSizeColumn(i);
			}*/
        //获取当前列的宽度，然后对比本列的长度，取最大值
        for (int columnNum = 0; columnNum <= maxColumn; columnNum++) {
            int columnWidth = sheet.getColumnWidth(columnNum) / 256;
            for (int rowNum = 1; rowNum <= sheet.getLastRowNum(); rowNum++) {
                HSSFRow currentRow;
                //当前行未被使用过
                if (sheet.getRow(rowNum) == null) {
                    currentRow = sheet.createRow(rowNum);
                } else {
                    currentRow = sheet.getRow(rowNum);
                }

                if (currentRow.getCell(columnNum) != null) {
                    HSSFCell currentCell = currentRow.getCell(columnNum);
                    //int length = Encoding.Default.GetBytes(currentCell.ToString()).Length;
                    int length = currentCell.toString().getBytes().length;
                    if (columnWidth < length) {
                        columnWidth = length;
                    }
                }
            }
            Double setWidth = 256 * 2.0;
            sheet.setColumnWidth(columnNum, columnWidth * setWidth.intValue());
        }
    }

    public static String getPath(String path) throws IOException {
        System.out.println(path);
        File file = new File(path);
        file.createNewFile();// 创建临时文件
        String filePath = file.getPath();
        filePath = filePath.replace("\\\\", "/");

        File dir = new File(file.getPath());
        // 如果这个目录不存在，则创建它。
        if (!dir.exists()) {
            dir.mkdir();
        }

        return filePath;
    }

    /**
     * @param workbook
     * @param fontsize
     * @return 单元格样式
     */
    private static HSSFCellStyle createCellStyle(HSSFWorkbook workbook, short fontsize, boolean flag, boolean flag1) {
        // TODO Auto-generated method stub
        HSSFCellStyle style = workbook.createCellStyle();
        //是否水平居中
        if (flag1) {
            style.setAlignment(HSSFCellStyle.ALIGN_CENTER);//水平居中
        }

        style.setVerticalAlignment(HSSFCellStyle.VERTICAL_CENTER);//垂直居中
        //创建字体
        HSSFFont font = workbook.createFont();
        //是否加粗字体
        if (flag) {
            font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);
        }
        font.setFontHeightInPoints(fontsize);
        //加载字体
        style.setFont(font);
        return style;
    }

}
