package cn.superdesk.libs.filesystem.provider;

import cn.superdesk.libs.common.http.HttpUtils;
import cn.superdesk.libs.filesystem.FSProvider;

/**
 * @author superdesk
 * @description
 * @date 2017年1月7日
 */
public abstract class AbstractProvider implements FSProvider {

    private static final String HTTP_PREFIX  = "http://";
    private static final String HTTPS_PREFIX = "https://";

    protected static final String DIR_SPLITER = "/";

    protected String urlprefix;

    protected String bucketName;

    protected String getFullPath(String file) {
        if (file.startsWith(HTTP_PREFIX) || file.startsWith(HTTPS_PREFIX)) {
            return file;
        }
        return urlprefix + file;
    }


    @Override
    public String downloadAndSaveAs(String file, String localSaveDir) {
        return HttpUtils.downloadFile(getDownloadUrl(file), localSaveDir);
    }

}
