package cn.superdesk.libs.kafka.serializer;

import org.apache.kafka.common.serialization.Deserializer;

import cn.superdesk.libs.common.serializer.SerializeUtils;

import kafka.serializer.Decoder;


/**
 * @author superdesk
 * @description
 * @date 2016年6月14日
 */
public class MessageDecoder implements Decoder<Object> {

    private Deserializer<Object> deserializer;

    public MessageDecoder() {
    }

    public MessageDecoder(Deserializer<Object> deserializer) {
        super();
        this.deserializer = deserializer;
    }

    @Override
    public Object fromBytes(byte[] bytes) {
        if (deserializer != null) return deserializer.deserialize(null, bytes);
        return SerializeUtils.deserialize(bytes);
    }
}
