package cn.superdesk.libs.mybatis.plugin.security;

import org.apache.ibatis.mapping.MappedStatement;
import org.apache.ibatis.mapping.SqlCommandType;
import org.apache.ibatis.plugin.Invocation;

import cn.superdesk.libs.common.SuperdeskBaseException;
import cn.superdesk.libs.mybatis.core.InterceptorHandler;
import cn.superdesk.libs.mybatis.plugin.SuperdeskMybatisInterceptor;

/**
 * @author superdesk
 * @description
 * @date 2018年11月11日
 */
public class SensitiveOperProtectHandler implements InterceptorHandler {

    @Override
    public void start(SuperdeskMybatisInterceptor context) {
    }

    @Override
    public void close() {
    }

    @Override
    public Object onInterceptor(Invocation invocation) throws Throwable {
        Object[]        objects = invocation.getArgs();
        MappedStatement ms      = (MappedStatement) objects[0];
        if (ms.getSqlCommandType().equals(SqlCommandType.DELETE)) {
            throw new SuperdeskBaseException(4003, "当前已开启敏感操作保护");
        }
        return null;
    }

    @Override
    public void onFinished(Invocation invocation, Object result) {

    }

    @Override
    public int interceptorOrder() {
        return 1;
    }

}
