package cn.superdesk.libs.mybatis.spring;

import org.apache.ibatis.session.Configuration;
import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.core.io.Resource;

import cn.superdesk.libs.common.util.ResourceUtils;
import cn.superdesk.libs.mybatis.MybatisConfigs;
import cn.superdesk.libs.mybatis.parser.MybatisMapperParser;
import cn.superdesk.libs.spring.InstanceFactory;
import cn.superdesk.libs.spring.SpringInstanceProvider;

/**
 * @author superdesk
 * @description
 * @date 2018年11月22日
 */
public class SqlSessionFactoryBean extends org.mybatis.spring.SqlSessionFactoryBean implements ApplicationContextAware {

    private String     groupName = "default";
    private Resource[] mapperLocations;

    public String getGroupName() {
        return groupName;
    }

    public void setGroupName(String groupName) {
        this.groupName = groupName;
    }

    @Override
    public void setMapperLocations(Resource[] mapperLocations) {
        super.setMapperLocations(mapperLocations);
        this.mapperLocations = mapperLocations;
    }

    @Override
    public void afterPropertiesSet() throws Exception {
        super.afterPropertiesSet();
        MybatisMapperParser.addMapperLocations(groupName, mapperLocations);
        String prefix = "default".equals(groupName) ? "superdesk.mybatis" : groupName + ".superdesk.mybatis";
        MybatisConfigs.addProperties(groupName, ResourceUtils.getAllProperties(prefix));
        Configuration configuration = getObject().getConfiguration();
        SuperdeskMybatisRegistry.register(groupName, configuration);
    }

    @Override
    public void setApplicationContext(ApplicationContext applicationContext) throws BeansException {
        InstanceFactory.setInstanceProvider(new SpringInstanceProvider(applicationContext));
    }


}
