package cn.superdesk.libs.mybatis.test.mapper;

import java.util.List;
import java.util.Map;

import cn.superdesk.libs.mybatis.core.BaseMapper;
import cn.superdesk.libs.mybatis.plugin.cache.annotation.Cache;
import cn.superdesk.libs.mybatis.plugin.pagination.Page;
import cn.superdesk.libs.mybatis.plugin.pagination.PageParams;
import cn.superdesk.libs.mybatis.plugin.pagination.annotation.Pageable;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import cn.superdesk.libs.mybatis.test.entity.UserEntity;

public interface UserEntityMapper extends BaseMapper<UserEntity,Integer> {

	@Cache
	List<UserEntity> findByType(short type);

	@Cache
	@Pageable
	List<UserEntity> findByStatus(short status);

	@Cache
	UserEntity findByMobile(@Param("mobile") String mobile);
	
	@Cache
	UserEntity findByLoginName(@Param("name") String name);

	@Cache
	@Pageable
	List<UserEntity> queryByExample(UserEntity user);

	@Cache
	int countByExample(UserEntity user);

	@Cache
	@Select("SELECT count(*) FROM users where type=#{type}")
	int countByType(@Param("type") int type);

	int updateType(@Param("ids") int[] ids, @Param("type") int type);

	void updateType2(UserEntity user);

	@Cache(expire = 300)
	public List<String> findMobileByIds(List<Integer> ids);

	Page<UserEntity> pageQuery(@Param("pageParam") PageParams pageParam, @Param("example") Map<String, Object> example);

	@Delete("delete from users where mobile = #{mobile}")
	public void delBymobile(@Param("mobile") String mobile);

	@Cache
	UserEntity findByWxUnionId(@Param("unionId") String unionId);

	@Cache(expire=300)
	String findWxUnionIdByUserId(@Param("userId") int userId);

}