package cn.superdesk.libs.rest;

import cn.superdesk.libs.rest.filter.DefaultWebFilter;
import cn.superdesk.libs.rest.filter.FilterConfig;
import org.glassfish.jersey.jackson.JacksonFeature;
import org.glassfish.jersey.server.ResourceConfig;
import org.glassfish.jersey.server.ServerProperties;
import org.springframework.web.filter.RequestContextFilter;

import com.fasterxml.jackson.jaxrs.json.JacksonJsonProvider;
import cn.superdesk.libs.rest.excetion.BaseExceptionMapper;
import cn.superdesk.libs.rest.resolver.ObjectMapperResolver;
import cn.superdesk.libs.rest.resolver.ValidationContextResolver;

import io.swagger.jaxrs.listing.SwaggerSerializers;

/**
 * @author superdesk
 * @description
 * @date 2016年1月16日
 */
public abstract class BaseApplicaionConfig extends ResourceConfig implements CustomConfig {

    public BaseApplicaionConfig() {
        //设置默认时区
        System.setProperty("user.timezone", "Asia/Shanghai");

        register(ValidationContextResolver.class);
        property(ServerProperties.BV_SEND_ERROR_IN_RESPONSE, true);
        property(ServerProperties.BV_DISABLE_VALIDATE_ON_EXECUTABLE_OVERRIDE_CHECK, true);

        this.packages(packages());

        register(ObjectMapperResolver.class);
        register(JacksonFeature.class);
        register(JacksonJsonProvider.class);
        register(new BaseExceptionMapper(createExcetionWrapper()));
        register(RequestContextFilter.class);

        register(DefaultWebFilter.class);
        //
        if (FilterConfig.apiDocEnabled()) {
            register(SwaggerSerializers.class);
        }
    }


}
