package cn.superdesk.test.sch;

import java.util.Date;

import org.apache.commons.lang3.RandomUtils;
import org.springframework.stereotype.Service;

import cn.superdesk.libs.common.util.DateUtils;
import cn.superdesk.libs.scheduler.AbstractJob;
import cn.superdesk.libs.scheduler.JobContext;
import cn.superdesk.libs.scheduler.annotation.ScheduleConf;

/**
 * @author
 * @description
 * @date 2016年1月28日
 * @Copyright (c) 2015, lifesense.com
 */
@Service
@ScheduleConf(cronExpr = "0/30 * * * * ?", jobName = "demoTask", executeOnStarted = true)
public class DemoTask extends AbstractJob {

    @Override
    public void doJob(JobContext context) throws Exception {
        System.out.println("\n=============\nDemoTask_1=====>" + context.getNodeId() + "--" + DateUtils.format(new Date()) + "\n===============\n");
        Thread.sleep(RandomUtils.nextLong(1000, 2000));
    }

    @Override
    public boolean parallelEnabled() {
        return false;
    }

}
