package cn.superdesk.libs.security;

import java.io.Serializable;
import java.util.List;

import cn.superdesk.libs.security.exception.UserNotFoundException;
import cn.superdesk.libs.security.exception.UserPasswordWrongException;
import cn.superdesk.libs.security.model.BaseUserInfo;
import cn.superdesk.libs.security.model.UserSession;

/**
 * @author superdesk
 * @description
 * @date 2018年11月30日
 */
public abstract class SecurityDecisionProvider {

    public String sessionIdName() {
        return "JSESSION_ID";
    }

    public int sessionExpireIn() {
        return 7200;
    }

    public String cookieDomain() {
        return null;
    }

    public boolean multiPointEnable() {
        return true;
    }

    public boolean keepCookie() {
        return true;
    }

    public Constants.CacheType cacheType() {
        return Constants.CacheType.local;
    }

    public abstract String contextPath();

    public abstract String[] anonymousUris();

    public abstract BaseUserInfo validateUser(String name, String password) throws UserNotFoundException, UserPasswordWrongException;

    public abstract List<String> findAllUriPermissionCodes();

    public abstract List<String> getUserPermissionCodes(Serializable userId);

    public abstract void authorizedPostHandle(UserSession session);
}
