package cn.superdesk.libs.springweb.base;

import java.io.IOException;

import javax.servlet.ReadListener;
import javax.servlet.ServletInputStream;

/**
 * @author superdesk
 * @description
 * @date 2018年3月7日
 */
public class CustomServletInputStreamWrapper extends ServletInputStream {

    private byte[] data;
    private int    idx = 0;

    /**
     * @param data
     */
    public CustomServletInputStreamWrapper(byte[] data) {
        if (data == null)
            data = new byte[0];
        this.data = data;
    }

    @Override
    public int read() throws IOException {
        if (idx == data.length)
            return -1;
        return data[idx++] & 0xff;
    }

    @Override
    public boolean isFinished() {
        return idx == data.length;
    }

    @Override
    public boolean isReady() {
        return true;
    }

    @Override
    public void setReadListener(ReadListener listener) {

    }

}
